/**
 * PI mittels Archimedes
 */
public class Archimedes
{
/**
 * Berechnung und Ausgabe der Naeherung von PI
 * (Rechnergenauigkeit)
 * und des absoluten Fehlers zu Math.PI.
 */
  public static void main(String[] args)
  {
    System.out.println
    ( "Methode von Archimedes zur Bestimmung von PI");
	
    //Iterationsanfang (Umfang vom 6-Eck)
    double a = 2 * Math.sqrt( 3), b = 3;

    //benoetigte Schritte zaehlen
    int schritte = 0;

    //Iterationsschritte (Verdoppelung der Ecken)
    while(a != b)
    {
      schritte++;
      a = ( 2 * a * b) / ( a + b);
      b = Math.sqrt( a * b);
    }

    // absoluter Fehler
    double absFehler = Math.abs( Math.PI - a);
    // double relFehler = Math.abs( Math.PI - a) / Math.PI;

    //Ausgabe
    System.out.println();
    System.out.println( "Schritte\t: " + schritte);
    System.out.println( "\"Archimedes-PI\"\t: " + a);
    System.out.println( "\"Math.PI\"\t: " + Math.PI);
    System.out.println( "Absoluter Fehler: " + absFehler);
  }
}

/*
Methode von Archimedes zur Bestimmung von PI

Schritte	: 26
"Archimedes-PI"	: 3.141592653589792
"Math.PI"	: 3.141592653589793
Absoluter Fehler: 1.3322676295501878E-15
*/
